import { type IType, type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrHomeworkquestion {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  HomeworkId!: IType<number, bigint>;
  BookId!: IType<number, bigint>;
  PageId!: IType<number, bigint>;
  QuestionId!: IType<number, bigint>;
  QuestionNo?: string;
  Score!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  QuestionGroupId!: IType<number, bigint> & Opt;
}

export const IcrHomeworkquestionSchema = defineEntity({
  class: IcrHomeworkquestion,
  comment: '作业',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    HomeworkId: p.bigint().name('HomeworkId').columnType('bigint').comment('作业Id').index('idx_ICR_HomeworkQuestion_01'),
    BookId: p.bigint().name('BookId').columnType('bigint').comment('书Id').index('idx_ICR_HomeworkQuestion_02'),
    PageId: p.bigint().name('PageId').columnType('bigint').comment('页Id').index('idx_ICR_HomeworkQuestion_03'),
    QuestionId: p.bigint().name('QuestionId').columnType('bigint').comment('问题Id').index('idx_ICR_HomeworkQuestion_04'),
    QuestionNo: p.string().name('QuestionNo').nullable().comment('题号'),
    Score: p.float().name('Score').comment('问题分数'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    QuestionGroupId: p.bigint().name('QuestionGroupId').columnType('bigint').comment('问题组Id').defaultRaw(`0`),
  },
});
